package mx.utils
{
   import mx.messaging.config.LoaderConfig;
   
   public class URLUtil
   {
      public static const SERVER_NAME_TOKEN:String = "{server.name}";
      
      public static const SERVER_PORT_TOKEN:String = "{server.port}";
      
      private static const SERVER_NAME_REGEX:RegExp = /\{server.name\}/g;
      
      private static const SERVER_PORT_REGEX:RegExp = /\{server.port\}/g;
      
      public function URLUtil()
      {
         super();
      }
      
      public static function getServerName(param1:String) : String
      {
         var _loc2_:String = null;
         var _loc3_:int = 0;
         _loc2_ = getServerNameWithPort(param1);
         _loc3_ = int(_loc2_.indexOf(":"));
         if(_loc3_ > 0)
         {
            _loc2_ = _loc2_.substring(0,_loc3_);
         }
         return _loc2_;
      }
      
      public static function isHttpsURL(param1:String) : Boolean
      {
         return param1 != null && param1.indexOf("https://") == 0;
      }
      
      public static function getFullURL(param1:String, param2:String) : String
      {
         var _loc3_:Number = NaN;
         if(param2 != null && !URLUtil.isHttpURL(param2))
         {
            if(URLUtil.isHttpURL(param1))
            {
               if(param2.charAt(0) == "/")
               {
                  _loc3_ = Number(param1.indexOf("/",8));
                  if(_loc3_ == -1)
                  {
                     _loc3_ = param1.length;
                  }
               }
               else
               {
                  _loc3_ = param1.lastIndexOf("/") + 1;
                  if(_loc3_ <= 8)
                  {
                     param1 += "/";
                     _loc3_ = param1.length;
                  }
               }
               if(_loc3_ > 0)
               {
                  param2 = param1.substring(0,_loc3_) + param2;
               }
            }
         }
         return param2;
      }
      
      public static function getServerNameWithPort(param1:String) : String
      {
         var _loc2_:int = 0;
         var _loc3_:int = 0;
         _loc2_ = param1.indexOf("/") + 2;
         _loc3_ = int(param1.indexOf("/",_loc2_));
         return _loc3_ == -1 ? param1.substring(_loc2_) : param1.substring(_loc2_,_loc3_);
      }
      
      public static function replaceProtocol(param1:String, param2:String) : String
      {
         return param1.replace(getProtocol(param1),param2);
      }
      
      public static function getProtocol(param1:String) : String
      {
         var _loc2_:int = 0;
         var _loc3_:int = 0;
         _loc2_ = int(param1.indexOf("/"));
         _loc3_ = int(param1.indexOf(":/"));
         if(_loc3_ > -1 && _loc3_ < _loc2_)
         {
            return param1.substring(0,_loc3_);
         }
         _loc3_ = int(param1.indexOf("::"));
         if(_loc3_ > -1 && _loc3_ < _loc2_)
         {
            return param1.substring(0,_loc3_);
         }
         return "";
      }
      
      public static function replaceTokens(param1:String) : String
      {
         var _loc2_:String = null;
         var _loc3_:int = 0;
         var _loc4_:String = null;
         var _loc5_:String = null;
         var _loc6_:uint = 0;
         _loc2_ = LoaderConfig.url == null ? "" : LoaderConfig.url;
         if(param1.indexOf(SERVER_NAME_TOKEN) > 0)
         {
            _loc4_ = URLUtil.getProtocol(_loc2_);
            _loc5_ = "localhost";
            if(_loc4_.toLowerCase() != "file")
            {
               _loc5_ = URLUtil.getServerName(_loc2_);
            }
            param1 = param1.replace(SERVER_NAME_REGEX,_loc5_);
         }
         _loc3_ = int(param1.indexOf(SERVER_PORT_TOKEN));
         if(_loc3_ > 0)
         {
            _loc6_ = URLUtil.getPort(_loc2_);
            if(_loc6_ > 0)
            {
               param1 = param1.replace(SERVER_PORT_REGEX,_loc6_);
            }
            else
            {
               if(param1.charAt(_loc3_ - 1) == ":")
               {
                  param1 = param1.substring(0,_loc3_ - 1) + param1.substring(_loc3_);
               }
               param1 = param1.replace(SERVER_PORT_REGEX,"");
            }
         }
         return param1;
      }
      
      public static function getPort(param1:String) : uint
      {
         var _loc2_:String = null;
         var _loc3_:int = 0;
         var _loc4_:uint = 0;
         var _loc5_:Number = NaN;
         _loc2_ = getServerNameWithPort(param1);
         _loc3_ = int(_loc2_.indexOf(":"));
         _loc4_ = 0;
         if(_loc3_ > 0)
         {
            _loc5_ = Number(_loc2_.substring(_loc3_ + 1));
            if(!isNaN(_loc5_))
            {
               _loc4_ = uint(int(_loc5_));
            }
         }
         return _loc4_;
      }
      
      public static function replacePort(param1:String, param2:uint) : String
      {
         var _loc3_:String = null;
         var _loc4_:int = 0;
         var _loc5_:int = 0;
         var _loc6_:int = 0;
         _loc3_ = "";
         _loc4_ = int(param1.indexOf(":"));
         _loc5_ = int(param1.indexOf(":",_loc4_ + 1));
         if(_loc5_ > -1)
         {
            _loc5_++;
            _loc6_ = int(param1.indexOf("/",_loc5_));
            _loc3_ = param1.substring(0,_loc5_) + param2.toString() + param1.substring(_loc6_,param1.length);
         }
         else
         {
            _loc6_ = int(param1.indexOf("/",_loc4_));
            if(_loc6_ > -1)
            {
               if(param1.charAt(_loc6_ + 1) == "/")
               {
                  _loc6_ = int(param1.indexOf("/",_loc6_ + 2));
               }
               if(_loc6_ > 0)
               {
                  _loc3_ = param1.substring(0,_loc6_) + ":" + param2.toString() + param1.substring(_loc6_,param1.length);
               }
               else
               {
                  _loc3_ = param1 + ":" + param2.toString();
               }
            }
            else
            {
               _loc3_ = param1 + ":" + param2.toString();
            }
         }
         return _loc3_;
      }
      
      public static function isHttpURL(param1:String) : Boolean
      {
         return param1 != null && (param1.indexOf("http://") == 0 || param1.indexOf("https://") == 0);
      }
   }
}

